package DX::Lib::FS::Action::SetPathMode;

use Moo;

has path_status => (is => 'ro', required => 1);
has mode => (is => 'ro', required => 1);

with 'DX::Role::Action';

sub expected_effect {
  my ($self) = @_;
  my $ps = $self->path_status;
  +(path_status => $ps->but(info => $ps->info->but(mode => $self->mode)));
}

sub _do_run {
  my ($self) = @_;
  chmod oct($self->mode), $self->path_status->path
    or die "Failed to chmod ${\$self->path_status->path} to ${\$self->mode}: $!";
  +(path_status => $self->path_status);
}

1;
